%define anolis_release 3
%define contentdir %{_datadir}/%{name}
%define docroot /var/www
%define suexec_caller apache
%define mmn 20120211
%define mmnisa %{mmn}%{__isa_name}%{__isa_bits}
%define vstring %(source /etc/os-release; echo ${NAME})
%global mpm event

%bcond_without pcre2
%bcond_with pcre

%undefine _package_note_flags

Summary: Apache HTTP Server
Name: httpd
Version: 2.4.58
Release: %{anolis_release}%{?dist}
License: ASL 2.0
URL: https://httpd.apache.org/
Source0: https://archive.apache.org/dist/%{name}/%{name}-%{version}.tar.bz2
Source3: %{name}.logrotate
Source4: instance.conf
Source5: %{name}-ssl-pass-dialog
Source6: %{name}.tmpfiles
Source7: %{name}.service
Source8: action-graceful.sh
Source9: action-configtest.sh
Source10: server-status.conf
Source11: %{name}.conf
Source12: 00-base.conf
Source13: 00-mpm.conf
Source14: 00-lua.conf
Source15: 01-cgi.conf
Source16: 00-dav.conf
Source17: 00-proxy.conf
Source18: 00-ssl.conf
Source19: 01-ldap.conf
Source20: 00-proxyhtml.conf
Source21: userdir.conf
Source22: ssl.conf
Source23: welcome.conf
Source24: manual.conf
Source25: 00-systemd.conf
Source26: 01-session.conf
Source27: 10-listen443.conf
Source28: %{name}.socket
Source29: 00-optional.conf
Source30: README.confd
Source31: README.confmod
Source32: %{name}.service.xml
Source33: htcacheclean.service.xml
Source34: %{name}.conf.xml
Source35: 00-brotli.conf
Source40: htcacheclean.service
Source41: htcacheclean.sysconf
Source42: %{name}-init.service
Source43: %{name}-ssl-gencerts
Source44: %{name}@.service
Source45: config.layout
Source46: apachectl.sh
Source47: apachectl.xml
Source48: apache-poweredby.png

Patch0001: httpd-2.4.43-apxs.patch
Patch0002: httpd-2.4.43-deplibs.patch
Patch0003: httpd-2.4.53-detect-systemd.patch
Patch0004: httpd-2.4.48-r1842929+.patch
Patch0005: httpd-2.4.43-mod_systemd.patch
Patch0006: httpd-2.4.53-export.patch
Patch0007: httpd-2.4.43-corelimit.patch
Patch0008: httpd-2.4.54-selinux.patch
Patch0009: httpd-2.4.43-gettid.patch
Patch0010: httpd-2.4.54-icons.patch
Patch0011: httpd-2.4.43-cachehardmax.patch
Patch0012: httpd-2.4.43-socket-activation.patch
Patch0013: httpd-2.4.43-sslciphdefault.patch
Patch0014: httpd-2.4.43-sslprotdefault.patch
Patch0015: httpd-2.4.43-r1861793+.patch
Patch0016: httpd-2.4.48-r1828172+.patch
Patch0017: httpd-2.4.43-logjournal.patch
Patch0018: httpd-2.4.53-separate-systemd-fns.patch
Patch0019: httpd-2.4.43-enable-sslv3.patch
Patch0021: httpd-2.4.46-htcacheclean-dont-break.patch
Patch0022: httpd-2.4.51-r1894152.patch

#https://github.com/apache/httpd/commit/1feb5e04a4f7b5f3f13cd40f9635144319dcf24a
Patch0023: fix-cve-2024-38475.patch

# modify for anolis
Patch1000: 1000-httpd-anolis-rebrand.patch

BuildRequires: gcc > 12.0
BuildRequires: autoconf
BuildRequires: pkgconfig
BuildRequires: findutils
BuildRequires: xmlto
BuildRequires: gnupg2
BuildRequires: perl-interpreter, perl-generators
BuildRequires: systemd-devel, systemd-rpm-macros
BuildRequires: zlib-devel
BuildRequires: libselinux-devel
BuildRequires: lua-devel
BuildRequires: brotli-devel
BuildRequires: apr-devel >= 1.5.0
BuildRequires: apr-util-devel >= 1.5.0
%if %{with pcre2}
BuildRequires: pcre2-devel
%endif
%if %{with pcre}
BuildRequires: pcre-devel > 5.0
%endif
Requires: system-logos(httpd-logo-ng)
Provides: webserver
Requires: %{name}-core = 0:%{version}-%{release}
Recommends: mod_http2
Recommends: mod_lua
%{?systemd_requires}

%description
The Apache HTTP Server Project is a collaborative software development effort
aimed at creating a robust, commercial-grade, featureful, and freely-available
source code implementation of an HTTP (Web) server. The project is jointly
managed by a group of volunteers located around the world, using the Internet
and the Web to communicate, plan, and develop the server and its related
documentation. This project is part of the Apache Software Foundation. In
addition, hundreds of users have contributed ideas, code, and documentation to
the project. This file is intended to briefly describe the history of the Apache
HTTP Server and recognize the many contributors.

%package core
Summary: %{name} minimal core
Provides: mod_dav = %{version}-%{release}
Provides: httpd-suexec = %{version}-%{release}
Provides: httpd-mmn = %{mmn}
Provides: httpd-mmn = %{mmnisa}
Provides: mod_proxy_uwsgi = %{version}-%{release}
Requires: /etc/mime.types
Requires: httpd-tools = %{version}-%{release}
Requires: httpd-filesystem = %{version}-%{release}
Requires(pre): httpd-filesystem
Conflicts: apr < 1.5.0-1
Obsoletes: mod_proxy_uwsgi < 2.0.17.1-2

%description core
The httpd-core package contains essential httpd binaries.

%package filesystem
Summary: The basic directory layout for the Apache HTTP Server
BuildArch: noarch
Requires(pre): /usr/sbin/useradd

%description filesystem
The %{name}-filesystem package contains the basic directory layout
for the Apache HTTP Server including the correct permissions
for the directories.

%package tools
Summary: Tools for use with the Apache HTTP Server

%description tools
The %{name}-tools package contains tools which can be used with
the Apache HTTP Server.

%package -n mod_ssl
Summary: SSL/TLS module for the Apache HTTP Server
Epoch: 1
BuildRequires: openssl-devel
Requires(pre): %{name}-filesystem
Requires: %{name} = 0:%{version}-%{release}
Requires: %{name}-mmn = %{mmnisa}
Requires: sscg >= 2.2.0, /usr/bin/hostname
Conflicts: openssl-libs < 1:1.0.1h
Conflicts: mod_nss

%description -n mod_ssl
The mod_ssl module provides strong cryptography for the Apache HTTP
server via the Secure Sockets Layer (SSL) and Transport Layer
Security (TLS) protocols.

%package -n mod_proxy_html
Summary: HTML and XML content filters for the Apache HTTP Server
Epoch: 1
Requires: %{name} = 0:%{version}-%{release}
Requires: %{name}-mmn = %{mmnisa}
BuildRequires: libxml2-devel
BuildRequires: make
Obsoletes: mod_proxy_html < 1:2.4.1

%description -n mod_proxy_html
The mod_proxy_html and mod_xml2enc modules provide filters which can
transform and modify HTML and XML content.

%package -n mod_ldap
Summary: LDAP authentication modules for the Apache HTTP Server
Requires: %{name} = %{version}-%{release}
Requires: %{name}-mmn = %{mmnisa}
Requires: apr-util-ldap

%description -n mod_ldap
The mod_ldap and mod_authnz_ldap modules add support for LDAP
authentication to the Apache HTTP Server.

%package -n mod_session
Summary: Session interface for the Apache HTTP Server
Requires: %{name} = 0:%{version}-%{release}
Requires: %{name}-mmn = %{mmnisa}

%description -n mod_session
The mod_session module and associated backends provide an abstract
interface for storing and accessing per-user session data.

%package -n mod_lua
Summary: Lua scripting support for the Apache HTTP Server
Requires: %{name} = 0:%{version}-%{release}
Requires: %{name}-mmn = %{mmnisa}

%description -n mod_lua
The mod_lua module allows the server to be extended with scripts
written in the Lua programming language.

%package devel
Summary: Development interfaces for the Apache HTTP Server
Requires: apr-devel
Requires: apr-util-devel
Requires: pkgconfig, libtool
Requires: %{name} = %{version}-%{release}

%description devel
The %{name}-devel package contains the header and library files
for developing with %{name}.

%package manual
Summary: Documentation for the Apache HTTP Server
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description manual
The %{name}-manual package contains the complete manual and
reference guide for the Apache HTTP Server. The information can
also be found at %{url}/docs/2.4/.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1

sed -i '/^#define PLATFORM/s/Unix/%{vstring}/' os/unix/os.h
sed -i '/suexec/s,setcap ,echo Skipping setcap for ,' Makefile.in

cp %{_sourcedir}/instance.conf .
sed < %{_sourcedir}/httpd.conf >> instance.conf '
0,/^ServerRoot/d;
/^ *CustomLog .logs/s,logs/,logs/${HTTPD_INSTANCE}_,
/^ *ErrorLog .logs/s,logs/,logs/${HTTPD_INSTANCE}_,
'
touch -r %{_sourcedir}/instance.conf instance.conf
cp -p %{_sourcedir}/server-status.conf server-status.conf

vmmn=`echo MODULE_MAGIC_NUMBER_MAJOR | cpp -include include/ap_mmn.h | sed -n '/^2/p'`
if test "x${vmmn}" != "x%{mmn}"; then
   : Error: Upstream MMN is now ${vmmn}, packaged MMN is %{mmn}
   : Update the mmn macro and rebuild.
   exit 1
fi

cp %{_sourcedir}/apache-poweredby.png ./docs/icons/apache_pb3.png
cp %{_sourcedir}/config.layout .

sed '
s,@MPM@,%{mpm},g
s,@DOCROOT@,%{docroot},g
s,@LOGDIR@,%{_localstatedir}/log/httpd,g
' < %{_sourcedir}/httpd.conf.xml \
    > httpd.conf.xml

xmlto man ./httpd.conf.xml
xmlto man %{_sourcedir}/htcacheclean.service.xml
xmlto man %{_sourcedir}/httpd.service.xml

xmlto man %{_sourcedir}/apachectl.xml

: Building with MMN %{mmn}, MMN-ISA %{mmnisa}
: Default MPM is %{mpm}, vendor string is '%{vstring}'
: Regex Engine: PCRE=%{with pcre} PCRE2=%{with pcre2}

%build
rm -rf srclib/{apr,apr-util,pcre}

autoheader && autoconf || exit 1

%{__perl} -pi -e "s:\@exp_installbuilddir\@:%{_libdir}/httpd/build:g" support/apxs.in

%set_build_flags

export LYNX_PATH=/usr/bin/links

./configure \
        --prefix=%{_sysconfdir}/httpd \
        --exec-prefix=%{_prefix} \
        --bindir=%{_bindir} \
        --sbindir=%{_sbindir} \
        --mandir=%{_mandir} \
        --libdir=%{_libdir} \
        --sysconfdir=%{_sysconfdir}/httpd/conf \
        --includedir=%{_includedir}/httpd \
        --libexecdir=%{_libdir}/httpd/modules \
        --datadir=%{contentdir} \
        --enable-layout=Fedora \
        --with-installbuilddir=%{_libdir}/httpd/build \
        --enable-mpms-shared=all \
        --with-apr=%{_prefix} --with-apr-util=%{_prefix} \
        --enable-suexec --with-suexec \
        --enable-suexec-capabilities \
        --with-suexec-caller=%{suexec_caller} \
        --with-suexec-docroot=%{docroot} \
        --without-suexec-logfile \
        --with-suexec-syslog \
        --with-suexec-bin=%{_sbindir}/suexec \
        --with-suexec-uidmin=1000 --with-suexec-gidmin=1000 \
        --with-brotli \
        --enable-pie \
%if %{with pcre2}
        --with-pcre2 \
%endif
%if %{with pcre}
        --with-pcre \
%endif
        --enable-mods-shared=all \
        --enable-ssl --with-ssl --disable-distcache \
        --enable-proxy --enable-proxy-fdpass \
        --enable-cache \
        --enable-disk-cache \
        --enable-ldap --enable-authnz-ldap \
        --enable-cgid --enable-cgi \
        --enable-cgid-fdpassing \
        --enable-authn-anon --enable-authn-alias \
        --enable-systemd \
        --disable-imagemap --disable-file-cache \
        --disable-http2 \
        --disable-md \
        $*
%make_build

%install
rm -rf %{buildroot}

%make_install

mkdir -p %{buildroot}%{_unitdir}
mkdir %{buildroot}%{_unitdir}/httpd.service.d
mkdir %{buildroot}%{_unitdir}/httpd.socket.d
mkdir %{buildroot}%{_sysconfdir}/httpd/conf.d %{buildroot}%{_sysconfdir}/httpd/conf.modules.d


install -p -m 644 %{_sourcedir}/httpd.service        %{buildroot}%{_unitdir}/httpd.service
install -p -m 644 %{_sourcedir}/htcacheclean.service %{buildroot}%{_unitdir}/htcacheclean.service
install -p -m 644 %{_sourcedir}/httpd.socket         %{buildroot}%{_unitdir}/httpd.socket
install -p -m 644 %{_sourcedir}/httpd@.service       %{buildroot}%{_unitdir}/httpd@.service
install -p -m 644 %{_sourcedir}/httpd-init.service   %{buildroot}%{_unitdir}/httpd-init.service



install -D -m 644 %{_sourcedir}/README.confd         %{buildroot}%{_sysconfdir}/httpd/conf.d/README
install -D -m 644 %{_sourcedir}/README.confmod       %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/README


for f in 00-base.conf 00-mpm.conf 00-lua.conf 01-cgi.conf 00-dav.conf \
         00-proxy.conf 00-ssl.conf 01-ldap.conf 00-proxyhtml.conf \
         01-ldap.conf 00-systemd.conf 01-session.conf 00-optional.conf \
         00-brotli.conf; do
  install -m 0644 -p %{_sourcedir}/$f \
        %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/$f
done

sed -i '/^#LoadModule mpm_%{mpm}_module /s/^#//' \
     %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/00-mpm.conf
touch -r %{_sourcedir}/00-mpm.conf \
     %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/00-mpm.conf


install -m 0644 -p %{_sourcedir}/10-listen443.conf \
      %{buildroot}%{_unitdir}/httpd.socket.d/10-listen443.conf

install -m 0644 -p %{_sourcedir}/welcome.conf \
      %{buildroot}%{_sysconfdir}/httpd/conf.d/welcome.conf
install -m 0644 -p %{_sourcedir}/ssl.conf \
      %{buildroot}%{_sysconfdir}/httpd/conf.d/ssl.conf
install -m 0644 -p %{_sourcedir}/manual.conf \
      %{buildroot}%{_sysconfdir}/httpd/conf.d/manual.conf
install -m 0644 -p %{_sourcedir}/userdir.conf \
      %{buildroot}%{_sysconfdir}/httpd/conf.d/userdir.conf


install -m 0644 docs/conf/extra/httpd-autoindex.conf \
      %{buildroot}%{_sysconfdir}/httpd/conf.d/autoindex.conf

rm -v docs/conf/extra/httpd-{ssl,userdir}.conf

rm %{buildroot}%{_sysconfdir}/httpd/conf/*.conf
install -m 0644 -p %{_sourcedir}/httpd.conf \
   %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf

mkdir %{buildroot}%{_sysconfdir}/sysconfig
install -m 0644 -p %{_sourcedir}/htcacheclean.sysconf \
   %{buildroot}%{_sysconfdir}/sysconfig/htcacheclean

mkdir -p %{buildroot}%{_prefix}/lib/tmpfiles.d
install -m 0644 -p %{_sourcedir}/httpd.tmpfiles \
   %{buildroot}%{_prefix}/lib/tmpfiles.d/httpd.conf

mkdir -p %{buildroot}%{_localstatedir}/lib/httpd \
         %{buildroot}/run/httpd/htcacheclean

sed -i '/^DavLockDB/d'                                             docs/conf/extra/*.conf
sed -i 's,@@ServerRoot@@/user.passwd,/etc/httpd/conf/user.passwd,' docs/conf/extra/*.conf
sed -i 's,@@ServerRoot@@/docs,%{docroot},'                         docs/conf/extra/*.conf
sed -i 's,@@ServerRoot@@,%{docroot},'                              docs/conf/extra/*.conf
sed -i 's,@@Port@@,80,'                                            docs/conf/extra/*.conf

sed 's,@HTTPDBIN@,%{_sbindir}/httpd,g' %{_sourcedir}/apachectl.sh \
    > apachectl.sh

mkdir -p %{buildroot}%{_localstatedir}/cache/httpd
mkdir -p %{buildroot}%{_localstatedir}/cache/httpd/proxy
mkdir -p %{buildroot}%{_localstatedir}/cache/httpd/ssl

echo %{mmnisa} > %{buildroot}%{_includedir}/httpd/.mmn
mkdir -p %{buildroot}%{_rpmconfigdir}/macros.d

cat > %{buildroot}%{_rpmconfigdir}/macros.d/macros.httpd <<EOF
%%_httpd_mmn %{mmnisa}
%%_httpd_apxs %%{_libdir}/httpd/build/vendor-apxs
%%_httpd_modconfdir %%{_sysconfdir}/httpd/conf.modules.d
%%_httpd_confdir %%{_sysconfdir}/httpd/conf.d
%%_httpd_contentdir %{contentdir}
%%_httpd_moddir %%{_libdir}/httpd/modules
%%_httpd_requires Requires: httpd-mmn = %%{_httpd_mmn}
EOF

mkdir %{buildroot}%{contentdir}/noindex %{buildroot}%{contentdir}/server-status
ln -s ../../testpage/index.html %{buildroot}%{contentdir}/noindex/index.html
install -m 0644 -p docs/server-status/* %{buildroot}%{contentdir}/server-status
rm -rf %{contentdir}/htdocs

find %{buildroot}%{contentdir}/manual \( \
    -name \*.xml -o -name \*.xml.* -o -name \*.ent -o -name \*.xsl -o -name \*.dtd \
    \) -print0 | xargs -0 rm -f

set +x
for f in `find %{buildroot}%{contentdir}/manual -name \*.html -type f`; do
   if test -f ${f}.en; then
      cp ${f}.en ${f}
      rm ${f}.*
   fi
done
set -x

rm -v %{buildroot}%{docroot}/html/*.html %{buildroot}%{docroot}/cgi-bin/*

ln -s ../../pixmaps/poweredby.png %{buildroot}%{contentdir}/icons/poweredby.png

ln -s ../../pixmaps/system-noindex-logo.png %{buildroot}%{contentdir}/icons/system_noindex_logo.png

rm -rf %{buildroot}/etc/httpd/{state,run}
ln -s ../..%{_localstatedir}/log/httpd %{buildroot}/etc/httpd/logs
ln -s ../..%{_localstatedir}/lib/httpd %{buildroot}/etc/httpd/state
ln -s /run/httpd %{buildroot}/etc/httpd/run
ln -s ../..%{_libdir}/httpd/modules %{buildroot}/etc/httpd/modules

mkdir -p %{buildroot}%{_libexecdir}
install -m 0755 %{_sourcedir}/httpd-ssl-pass-dialog %{buildroot}%{_libexecdir}/httpd-ssl-pass-dialog

install -m 0755 %{_sourcedir}/httpd-ssl-gencerts %{buildroot}%{_libexecdir}/httpd-ssl-gencerts

install -m 0755 apachectl.sh %{buildroot}%{_sbindir}/apachectl
touch -r %{_sourcedir}/apachectl.sh %{buildroot}%{_sbindir}/apachectl
mkdir -p %{buildroot}%{_libexecdir}/initscripts/legacy-actions/httpd
for f in graceful configtest; do
    install -p -m 0755 %{_sourcedir}/action-${f}.sh \
            %{buildroot}%{_libexecdir}/initscripts/legacy-actions/httpd/${f}
done

mkdir -p %{buildroot}/etc/logrotate.d
install -m 0644 -p %{_sourcedir}/httpd.logrotate \
        %{buildroot}/etc/logrotate.d/httpd

install -d %{buildroot}%{_mandir}/man8 %{buildroot}%{_mandir}/man5
install -m 0644 -p httpd.service.8 httpd-init.service.8 httpd.socket.8 \
        httpd@.service.8 htcacheclean.service.8 apachectl.8 \
        %{buildroot}%{_mandir}/man8
install -m 0644 -p httpd.conf.5 \
        %{buildroot}%{_mandir}/man5

sed -e "s|/usr/local/apache2/conf/httpd.conf|/etc/httpd/conf/httpd.conf|" \
    -e "s|/usr/local/apache2/conf/mime.types|/etc/mime.types|" \
    -e "s|/usr/local/apache2/conf/magic|/etc/httpd/conf/magic|" \
    -e "s|/usr/local/apache2/logs/error_log|/var/log/httpd/error_log|" \
    -e "s|/usr/local/apache2/logs/access_log|/var/log/httpd/access_log|" \
    -e "s|/usr/local/apache2/logs/httpd.pid|/run/httpd/httpd.pid|" \
    -e "s|/usr/local/apache2|/etc/httpd|" < docs/man/httpd.8 \
  > %{buildroot}%{_mandir}/man8/httpd.8

sed -i '/.*DEFAULT_..._LIBEXECDIR/d;/DEFAULT_..._INSTALLBUILDDIR/d' \
    %{buildroot}%{_includedir}/httpd/ap_config_layout.h

sed -i '/instdso/s,top_srcdir,top_builddir,' \
    %{buildroot}%{_libdir}/httpd/build/special.mk

cp -p %{buildroot}%{_libdir}/httpd/build/config_vars.mk \
      %{buildroot}%{_libdir}/httpd/build/vendor_config_vars.mk

sed -e '/^CFLAGS/s,=.*$,= -O2 -g -Wall,' \
    -e '/^LIBTOOL/s,/.*/libtool,%{_bindir}/libtool,' \
    -i %{buildroot}%{_libdir}/httpd/build/config_vars.mk
diff -u %{buildroot}%{_libdir}/httpd/build/vendor_config_vars.mk \
     %{buildroot}%{_libdir}/httpd/build/config_vars.mk || true

sed 's/config_vars.mk/vendor_config_vars.mk/' \
    %{buildroot}%{_bindir}/apxs \
    > %{buildroot}%{_libdir}/httpd/build/vendor-apxs
touch -r %{buildroot}%{_bindir}/apxs \
      %{buildroot}%{_libdir}/httpd/build/vendor-apxs
chmod 755 %{buildroot}%{_libdir}/httpd/build/vendor-apxs

rm -vf \
      %{buildroot}%{_libdir}/*.exp \
      %{buildroot}/etc/httpd/conf/mime.types \
      %{buildroot}%{_libdir}/httpd/modules/*.exp \
      %{buildroot}%{_libdir}/httpd/build/config.nice \
      %{buildroot}%{_bindir}/{ap?-config,dbmmanage} \
      %{buildroot}%{_sbindir}/{checkgid,envvars*} \
      %{buildroot}%{contentdir}/htdocs/* \
      %{buildroot}%{_mandir}/man1/dbmmanage.* \
      %{buildroot}%{contentdir}/cgi-bin/*

rm -rf %{buildroot}/etc/httpd/conf/{original,extra}


%pre filesystem
getent group apache >/dev/null || groupadd -g 48 -r apache
getent passwd apache >/dev/null || \
  useradd -r -u 48 -g apache -s /sbin/nologin \
    -d %{contentdir} -c "Apache" apache
exit 0

%post
%systemd_post httpd.service htcacheclean.service httpd.socket

%preun
%systemd_preun httpd.service htcacheclean.service httpd.socket

%postun
%systemd_postun httpd.service htcacheclean.service httpd.socket

%posttrans
test -f /etc/sysconfig/httpd-disable-posttrans || \
  /bin/systemctl try-restart --no-block httpd.service htcacheclean.service >/dev/null 2>&1 || :

%check
make -C server exports.o
nm --defined httpd > exports-actual.list
set +x
rv=0
nm --defined-only server/exports.o | \
  sed -n '/ap_hack_/{s/.* ap_hack_//;/^ap[ru]/d;p;}' | \
  while read sym; do
    if ! grep -q " "$sym\$ exports-actual.list; then
     echo ERROR: Symbol $sym missing in httpd exports
     rv=1
    fi
  done
if [ $rv -eq 0 ]; then
  echo PASS: Symbol export list verified.
fi
if readelf -d %{buildroot}%{_libdir}/httpd/modules/*.so | grep TEXTREL; then
   echo FAIL: Modules contain non-relocatable code
   rv=1
else
   echo PASS: No non-relocatable code in module builds
fi
for f in %{buildroot}%{_libdir}/httpd/modules/*.so; do
  m=${f##*/}
  if ! grep -q $m %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/*.conf; then
    echo FAIL: Module $m not configured.  Disable it, or load it.
    rv=1
   else
    echo PASS: Module $m is configured and loaded.
  fi
done
mods=`grep -h ^LoadModule %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/*.conf | sed 's,.*modules/,,'`
for m in $mods; do
  f=%{buildroot}%{_libdir}/httpd/modules/${m}
  if ! test -x $f; then
    echo FAIL: Module $m is configured but not built.
    rv=1
  else
    echo PASS: Loaded module $m is installed.
  fi
done
set -x
exit $rv

%files
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/00-brotli.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/00-systemd.conf
%{_libdir}/httpd/modules/mod_brotli.so
%{_libdir}/httpd/modules/mod_systemd.so

%{_unitdir}/httpd.service
%{_unitdir}/httpd@.service
%{_unitdir}/htcacheclean.service
%{_unitdir}/*.socket

%{_mandir}/man8/*
%{_mandir}/man5/*
%exclude %{_mandir}/man8/httpd-init.*

%files core
%license LICENSE
%doc docs/conf/extra/*.conf
%doc instance.conf server-status.conf
%{_sysconfdir}/httpd/modules
%{_sysconfdir}/httpd/logs
%{_sysconfdir}/httpd/state
%{_sysconfdir}/httpd/run

%dir %{_sysconfdir}/httpd/conf
%config(noreplace) %{_sysconfdir}/httpd/conf/httpd.conf
%config(noreplace) %{_sysconfdir}/httpd/conf/magic
%config(noreplace) %{_sysconfdir}/logrotate.d/httpd
%config(noreplace) %{_sysconfdir}/httpd/conf.d/*.conf
%exclude %{_sysconfdir}/httpd/conf.d/ssl.conf
%exclude %{_sysconfdir}/httpd/conf.d/manual.conf

%dir %{_sysconfdir}/httpd/conf.modules.d
%{_sysconfdir}/httpd/conf.modules.d/README
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/*.conf
%exclude %{_sysconfdir}/httpd/conf.modules.d/00-brotli.conf
%exclude %{_sysconfdir}/httpd/conf.modules.d/00-systemd.conf
%exclude %{_sysconfdir}/httpd/conf.modules.d/00-ssl.conf
%exclude %{_sysconfdir}/httpd/conf.modules.d/00-proxyhtml.conf
%exclude %{_sysconfdir}/httpd/conf.modules.d/00-lua.conf
%exclude %{_sysconfdir}/httpd/conf.modules.d/01-ldap.conf
%exclude %{_sysconfdir}/httpd/conf.modules.d/01-session.conf

%config(noreplace) %{_sysconfdir}/sysconfig/htcacheclean
%{_prefix}/lib/tmpfiles.d/httpd.conf

%dir %{_libexecdir}/initscripts/legacy-actions/httpd
%{_libexecdir}/initscripts/legacy-actions/httpd/*

%{_sbindir}/ht*
%{_sbindir}/fcgistarter
%{_sbindir}/apachectl
%{_sbindir}/rotatelogs
%caps(cap_setuid,cap_setgid+pe) %attr(510,root,%{suexec_caller}) %{_sbindir}/suexec

%dir %{_libdir}/httpd
%dir %{_libdir}/httpd/modules
%{_libdir}/httpd/modules/mod*.so
%exclude %{_libdir}/httpd/modules/mod_brotli.so
%exclude %{_libdir}/httpd/modules/mod_systemd.so
%exclude %{_libdir}/httpd/modules/mod_auth_form.so
%exclude %{_libdir}/httpd/modules/mod_ssl.so
%exclude %{_libdir}/httpd/modules/mod_*ldap.so
%exclude %{_libdir}/httpd/modules/mod_proxy_html.so
%exclude %{_libdir}/httpd/modules/mod_xml2enc.so
%exclude %{_libdir}/httpd/modules/mod_session*.so
%exclude %{_libdir}/httpd/modules/mod_lua.so

%dir %{contentdir}/error
%dir %{contentdir}/error/include
%dir %{contentdir}/noindex
%dir %{contentdir}/server-status
%{contentdir}/icons/*
%{contentdir}/error/README
%{contentdir}/error/*.var
%{contentdir}/error/include/*.html
%{contentdir}/noindex/index.html
%{contentdir}/server-status/*

%attr(0710,root,apache) %dir /run/httpd
%attr(0700,apache,apache) %dir /run/httpd/htcacheclean
%attr(0700,root,root) %dir %{_localstatedir}/log/httpd
%attr(0700,apache,apache) %dir %{_localstatedir}/lib/httpd
%attr(0700,apache,apache) %dir %{_localstatedir}/cache/httpd
%attr(0700,apache,apache) %dir %{_localstatedir}/cache/httpd/proxy


%files filesystem
%dir %{_sysconfdir}/httpd
%dir %{_sysconfdir}/httpd/conf.d
%{_sysconfdir}/httpd/conf.d/README
%dir %{docroot}
%dir %{docroot}/cgi-bin
%dir %{docroot}/html
%dir %{contentdir}
%dir %{contentdir}/icons
%attr(755,root,root) %dir %{_unitdir}/httpd.service.d
%attr(755,root,root) %dir %{_unitdir}/httpd.socket.d

%files tools
%{_bindir}/*
%{_mandir}/man1/*
%exclude %{_bindir}/apxs
%exclude %{_mandir}/man1/apxs.1*

%files -n mod_ssl
%{_libdir}/httpd/modules/mod_ssl.so
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/00-ssl.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.d/ssl.conf
%attr(0700,apache,root) %dir %{_localstatedir}/cache/httpd/ssl
%{_unitdir}/httpd-init.service
%{_libexecdir}/httpd-ssl-pass-dialog
%{_libexecdir}/httpd-ssl-gencerts
%{_unitdir}/httpd.socket.d/10-listen443.conf
%{_mandir}/man8/httpd-init.*

%files -n mod_proxy_html
%{_libdir}/httpd/modules/mod_proxy_html.so
%{_libdir}/httpd/modules/mod_xml2enc.so
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/00-proxyhtml.conf

%files -n mod_ldap
%{_libdir}/httpd/modules/mod_*ldap.so
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/01-ldap.conf

%files -n mod_session
%{_libdir}/httpd/modules/mod_session*.so
%{_libdir}/httpd/modules/mod_auth_form.so
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/01-session.conf

%files -n mod_lua
%{_libdir}/httpd/modules/mod_lua.so
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/00-lua.conf

%files devel
%{_includedir}/httpd
%{_bindir}/apxs
%dir %{_libdir}/httpd/build
%{_libdir}/httpd/build/*.mk
%{_libdir}/httpd/build/*.sh
%{_libdir}/httpd/build/vendor-apxs
%{_rpmconfigdir}/macros.d/macros.httpd
%{_mandir}/man1/apxs.1*


%files manual
%{contentdir}/manual
%config(noreplace) %{_sysconfdir}/httpd/conf.d/manual.conf

%files doc
%doc ABOUT_APACHE README CHANGES VERSIONING NOTICE


%changelog
* Fri Aug 02 2024 yangxinyu <yangxinyu@nfschina.com> - 2.4.58-3
- fix-cve-2024-38475

* Thu Dec 21 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.4.58-2
- rebuild

* Fri Oct 20 2023 Funda Wang <fundawang@yeah.net> - 2.4.58-1
- New version 2.4.58

* Tue Apr 11 2023 Ziyang Zhang <ZiyangZhang@linux.alibaba.com> -2.4.57-2
- Optimize spec file

* Fri Apr 7 2023 Funda Wang <fundawang@yeah.net> - 2.4.57-1
- New version 2.4.57

* Tue Mar 7 2023 Funda Wang <fundawang@yeah.net> - 2.4.56-1
- New version 2.4.56

* Wed Jan 18 2023 Funda Wang <fundawang@yeah.net> - 2.4.55-1
- New version 2.4.55

* Wed Aug 31 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.4.54-1
- update httpd to 2.4.54

* Mon May 23 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.4.53-1
- init from upstream
